SystemOrganization addCategory: #'Sight-Path-Omni'!

STbTestCase subclass: #SOmniTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Path-Omni'!

!SOmniTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/9/2010 14:14:58.348'!
testFooBar
	| sut timesCalled inspectedActivation wasCalled |
	self undoInTearDownDo: [
		sut := self wrap: self exampleMethod using: MwBlockMethodWrapper ].
		
	inspectedActivation := 1.
	timesCalled := 0.
	wasCalled := false.
	sut beforeBlock: [ :receiver :arguments |
		timesCalled := timesCalled + 1. 
		(inspectedActivation = timesCalled) ifTrue: [ wasCalled := true ] ].
	
	self runExampleTests.
	self assert: true equals: wasCalled. ! !

!SOmniTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:22:15.966'!
testInstanceCounting
	| instanceCounter receiverRecorder |
	instanceCounter := SInstanceCountingWrapper installInClass: STbPerson.
	receiverRecorder := self wrap: self exampleMethod using: SReceiverRecordingWrapper.
	self createdWrappers addAll: { instanceCounter. receiverRecorder }.
	
	self runExampleTests.
	self assert: 1 equals: (instanceCounter numberOf: receiverRecorder receiver)
	! !

!SOmniTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 20:27:12.903'!
testLastActivationThatSetsInstVarToValue
	| calls instVarName wrapper currentCall isValueDifferent inspectedValue |
	calls := OrderedCollection new.
	instVarName := self exampleInstVarName.
	
	"receiver := self wrap: self exampleMethod using: SReceiverRecordingWrapper.
	self runExampleTests."
	
	inspectedValue := ''.
	
	self undoInTearDownDo: [
		self exampleSubclass withAllSuperclassesDo: [ :c | 
			(c whichSelectorsAssign: instVarName) do: [ :s | 
				wrapper := self wrapOn: s inClass: c using: MwBlockMethodWrapper.
				wrapper beforeBlock: [ :receiver :arguments |
					receiver instVarNamed: instVarName ] ] ] ].
	
	" schnittmenge aus den selektoren oben und dem call tree, anders berechnet, 
	  ich muss prfen ob die methoden auch gecovered werden "
	
	" ich merke mir, wie oft ein wrapper aufgerufen wird und 
	  bei welchem Aufruf der wert gesetzt wird. "
	
	" ich schreibe mir den wrapper weg "
	
	" merke ich mir den Wert vor oder hinter dem aufruf? - problem ist, 
	dass whrend eines methode, in welcher der wert gendert wird, auch die zielaktivierung erreicht wird
	in dem dynamischen extent ..."
	
	"bis zum n-ten Aufruf von firstname - inspected Activation" 
	STbEmployee whichSelectorsStoreInto: 'firstname'.
	STbEmployee withAllSuperclasses select 
	! !

!SOmniTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/12/2010 15:30:50.003'!
testReceiverRecording
	| sut |
	sut := self wrap: self exampleMethod using: SReceiverRecordingWrapper.
	self runExampleTests.
	self assert: sut receiver class equals: self exampleMethod methodClass.! !

!SOmniTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/7/2010 11:33:31.419'!
testToDo
	" all nodes, where a particular instance is accessed or modified - while modifying seems hard "
	" the path that leads to setting an inst var to the particular value or instance "
	" fr value, was ist die letzte stelle vor dem ausgewhlten punkt, 
	  an dem diese inst var auf folgenden wert gesetzt wird. "
	" fr value, was ist die letzte stelle, an der die inst var auf diese instanz gesetzt wird "
	! !

MwMethodWrapper subclass: #SInstanceCountingWrapper
	instanceVariableNames: 'instances'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Path-Omni'!

!SInstanceCountingWrapper class methodsFor: 'instance creation' stamp: 'bs 7/6/2010 15:02:29.619'!
installInClass: aClass
	^ (self on: #basicNew inClass: aClass class)	
		install;
		yourself	! !

!SInstanceCountingWrapper methodsFor: 'accessing' stamp: 'bs 7/6/2010 14:49:29.747'!
instances
	^ instances ifNil: [ instances := OrderedCollection new ]! !

!SInstanceCountingWrapper methodsFor: 'accessing' stamp: 'bs 7/6/2010 14:47:40.164'!
instances: anObject
	instances := anObject! !

!SInstanceCountingWrapper methodsFor: 'as yet unclassified' stamp: 'bs 7/6/2010 15:12:52.346'!
numberOf: anInstance
	^ self instances indexOf: anInstance.! !

!SInstanceCountingWrapper methodsFor: 'evaluating' stamp: 'bs 7/6/2010 14:51:44.236'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	| newInstance |
	newInstance := self clientMethod valueWithReceiver: anObject arguments: anArrayOfObjects.
	self instances add: newInstance.
	^ newInstance.! !

MwMethodWrapper subclass: #SReceiverRecordingWrapper
	instanceVariableNames: 'receiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Path-Omni'!

!SReceiverRecordingWrapper methodsFor: 'accessing' stamp: 'bs 7/6/2010 14:15:16.894'!
receiver
	^ receiver! !

!SReceiverRecordingWrapper methodsFor: 'accessing' stamp: 'bs 7/6/2010 14:15:16.9'!
receiver: anObject
	receiver := anObject! !

!SReceiverRecordingWrapper methodsFor: 'evaluating' stamp: 'bs 7/6/2010 14:14:54.255'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	self receiver: anObject.
	^ self clientMethod valueWithReceiver: anObject arguments: anArrayOfObjects.! !
